// [TPT] - IP Country

#pragma once
#include "loggable.h"
#include "libGeoIP/GeoIP.h"
#include "libGeoIP/GeoIPCity.h"
#include "CxImage/xImage.h"

class CIP2Country : public CLoggable
{
public:
	CIP2Country();
	~CIP2Country();	
	CString GetCountryFromIP(uint32 fullUserIP);
	CString GetCountryISOFromIP(uint32 fullUserIP);
	int Compare(CString country1, CString country2);
	CxImage GetCountryFlag(uint32 fullUserIP);
private:	
	GeoIP * gi;
	GeoIPDBTypes db_loaded;
	CRBMap<CString, CxImage> country_flags;
	HINSTANCE _hCountryFlagDll;	
	void LoadFromFile();
};